;Twistoflex by ToKeN 2004
;/twistoflex to run

on *:LOAD: {
  echo Twist-O-Flex by ToKeN Loaded
  editbox -a /twistoflex
  editbox -s /twistoflex
}
alias twistoflex {
  if (!$isfile($+($scriptdir,tex13.bmp))) { echo Error: ToKeN was unable to locate $+($scriptdir,tex13.bmp) | .halt }
  window -oCdpka +Snt @TwistOFlex 0 0 256 256
  window -hl @twist.circ
  clear @twist.circ
  unset %twist*
  %twist.circ = 0
  %twist.circ2 = 0
  twist.intro
}
alias twist.intro {
  drawrect -nfr @TwistOflex 0 1 0 0 256 256
  var %t = drawtext -nr @TwistOflex $rgb(250,250,250) "OCR A Extended" , %a = 1
  while (%a <= $line(@twist.circ,0)) {
    tokenize 32 $line(@twist.circ,%a)
    if ($3 <= 0) { dline @twist.circ %a | goto next }
    drawrect $+(-ner,$iif(%twist.circ2 >= 1,f,$null)) @TwistOflex $rgb($calc($3 / 4),$calc($3 / 4),$3) $calc($3 / 75) $1 $2 $4 $4
    rline @twist.circ %a $calc($1 - 1) $calc($2 - 1) $calc($3 - $iif(%twist.circ2 == 2,3,1)) $calc($4 + 2)
    :next
    inc %a
  }
  %t 12 10 10 Twist-o-flex >> Intro Screen
  if (%twist.read) {
    %t 10 10 50 Twist-o-flex is an effect that is too 
    %t 10 10 60 slow to be performed in realtime and
    %t 10 10 70 thus has to be pre-cached.
    %t 10 10 100 Pre-caching may take several minutes
    %t 10 10 110 on slow machines and thus will require
    %t 10 10 120 your patience.

    %t 10 10 150 Press start to begin pre-caching.
    drawrect -nr @TwistOflex $rgb(250,250,250) 1 195 208 41 10
    %t 10 201 206 Start
  }
  %t 10 12 206 By ToKeN 2004
  if (!%twist.read) {
    drawrect -nr @TwistOflex $rgb(250,250,250) 1 195 208 41 10
    %t 10 203 206 Read
  }
  drawdot @twistoflex
  inc %twist.circ
  if (%twist.circ >= 20) { aline @twist.circ $rand(0,256) $rand(0,256) 255 1 | %twist.circ = 0 }
  .timert -hom 1 0 twist.intro
}
menu @twistoflex {
  sclick: { 
    if (%twist.1) { if (!%twist.c) { %twist.c = 1 } | else { unset %twist.c } | .halt }
    if (%twist.circ2) {

      if ($inrect($mouse.x,$mouse.y,130,74,22,12)) { %twist.q1 = 10 | %twist.q2 = 20 | %twist.quala = .6 | var %qual = Low }
      if ($inrect($mouse.x,$mouse.y,160,74,22,12)) { %twist.q1 = 5 | %twist.q2 = 10 | %twist.quala = .3 | var %qual = Medium }
      if ($inrect($mouse.x,$mouse.y,190,74,22,12)) { %twist.q1 = 1 | %twist.q2 = 2 | %twist.quala = .1 | var %qual = High }
      if (!%qual) { goto next }
      var %t = drawtext -r @TwistOflex $rgb(250,250,250) "OCR A Extended"
      %t 10 10 100 >> %qual quality setting selected
      %t 10 10 110 >> Rendering initiated...
      drawrect -r @TwistOflex $rgb(250,250,250) 1 10 124 200 20
      %twist.a = 1 | %twist.angle = 0
      twistoflex.run1
      .halt
    }
    :next
    if ($inrect($mouse.x,$mouse.y,195,208,41,10)) && (%twist.circ2 >= 0) { 
      if (%twist.read) { .timert off | unset %twist.circ2 | twistoflex.run.load }
      else { %twist.read = 1 }
    }
    inc %twist.circ2
    if (%twist.circ2 == 3) { %twist.circ2 = 0 } 
  }
}
alias twistoflex.run.load {
  drawrect -nfr @TwistOflex 0 1 0 0 256 256
  var %t = drawtext -nr @TwistOflex $rgb(250,250,250) "OCR A Extended" , %a = 1

  %t 12 10 10 Twist-o-flex >> Loading...
  %t 10 10 50 >> Launching Cache windows... 
  drawdot @twistoflex

  window -hp +d @twist.cache 0 0 256 256

  while (%a != 100) {
    window -hp +d @twist.cache [ $+ [ %a ] ] 0 0 256 256
    inc %a
  }
  %t 10 10 60 >> Cache windows complete 
  %t 10 10 70 >> Select Quality:
  drawrect -nr @TwistOflex $rgb(250,250,250) 1 130 74 22 12
  drawrect -nr @TwistOflex $rgb(250,250,250) 1 160 74 22 12
  drawrect -nr @TwistOflex $rgb(250,250,250) 1 190 74 22 12
  %t 10 132 73 Low
  %t 10 162 73 Med
  %t 10 195 73 Hi
  %t 10 10 86 (Higher quality = slower rendering)
  drawdot @twistoflex



}
alias twistoflex.run1 {

  if (%twist.a != 50) {
    var %x = 0, %y = 0, %w = 256, %h = 256
    inc %twist.angle %twist.quala
    %angle2 = 360

    while (%w > %x) && (%h > %y) {
      inc %x %twist.q1
      inc %y %twist.q1
      dec %w %twist.q2
      dec %h %twist.q2
      dec %angle2 %twist.angle
      drawpic -c @twist.cache 0 0 $+(",$scriptdir,tex13.bmp,")
      drawrot -cb @twist.cache 255 %angle2 %x %y %w %h
      drawcopy -t @twist.cache 255 %x %y %w %h @twist.cache [ $+ [ %twist.a ] ] %x %y
    }
    inc %twist.a
    drawrect -fr @TwistOflex $rgb(250,250,250) 1 12 126 $calc((%twist.a / 100) * 196) 16

    .timert -om 1 0 twistoflex.run1
    .halt
  }
  %twist.a = 50 | %twist.angle = 0
  twistoflex.run2
}

alias twistoflex.run2 {
  if (%twist.a != 100) {
    var %x = 0, %y = 0, %w = 256, %h = 256
    inc %twist.angle %twist.quala
    %angle2 = 0
    while (%w > %x) && (%h > %y) {
      inc %x %twist.q1
      inc %y %twist.q1
      dec %w %twist.q2
      dec %h %twist.q2
      inc %angle2 %twist.angle
      drawpic -c @twist.cache 0 0 $+(",$scriptdir,tex13.bmp,")
      drawrot -cb @twist.cache 255 %angle2 %x %y %w %h
      drawcopy -t @twist.cache 255 %x %y %w %h @twist.cache [ $+ [ %twist.a ] ] %x %y

    }
    inc %twist.a

    drawrect -fr @TwistOflex $rgb(250,250,250) 1 12 126 $calc((%twist.a / 100) * 196) 16
    .timert -om 1 0 twistoflex.run2
    .halt
  }
  %twist.1 = 1
  %twist.2 = 1
  %twist.3 = 1
  twistprocess
}
alias twistprocess {
  %twist.1 = $int($calc(($sin(%twist.2).deg) * 100 -50))
  inc %twist.2 $calc(1 + %twist.1 / 100))
  if (%twist.1 == 0) { %twist.1 = 1 }
  if (%twist.1 < 0) { var %a = 50 + $abs(%twist.1) }
  else { var %a = %twist.1 }
  if (%a == 50) { %a = 49 }
  if (%a >= 100) { %a = 99 | %twist.1 = 1 | %twist.2 = 1 }
  drawrect -nfr @twistoflex $rgb(255,255,255) 1 0 0 256 256

  drawcopy -mn @twist.cache [ $+ [ %a ] ] 0 0 250 250 @twistoflex 0 -8 240 240

  if (%twist.c) { 
    drawrect -infr @twistoflex $rgb(%twist.2,$calc(%twist.2 * %a / 11),$calc(%twist.2 * %a / 11)) 1 0 0 256 256 
  }

  drawtext -nr @twistoflex $rgb(0,0,0) Tahoma 10 5 10 Greetings: StanZ & Epsilon @ http://www.picwin.tk/
  drawdot @twistoflex 
  .timertwist -ho 1 0 twistprocess  
}
on *:CLOSE:@Twistoflex: {
  .timert off
  .timertwist off
  unset %twist*
  var %a = 1
  while (%a != 200) {
    window -c @twist.cache [ $+ [ %a ] ]
    inc %a
  }
  window -c @twist.circ
  window -c @twist.cache
}
